/********************************************
 * UTIA AV CR, v.v.i
 * Signal Processing Department
 * Pod Vodarenskou vezi 4
 * 182 08 Prague
 * Czech Republic
 * web: http://zs.utia.cas.cz
 * contact: sp@utia.cz
 *
 * Filename: i2c_ps.h
 * Date: 17.03.2021
 * Author: Lukas Kohout <kohoutl@utia.cas.cz>
 * Description:
 *
 * Changelog:
 *
 *
 *
 *
 ********************************************/


#ifndef _I2C_PS_FILE_
#define _I2C_PS_FILE_

#include <xiicps.h>


#define I2C_PS_SCLK_RATE_100_KHZ  100000
#define I2C_PS_SCLK_RATE_400_KHZ  400000


// TEBF0808 - TCA9548ARGER - U27
#define I2C_PS_9548_SLAVE_ADDR    0x77
#define I2C_PS_9548_SEL_PMOD      0x01  // Port 0
#define I2C_PS_9548_SEL_A         0x02  // Port 1
#define I2C_PS_9548_SEL_FFA       0x04  // Port 2
#define I2C_PS_9548_SEL_FFB       0x08  // Port 3
#define I2C_PS_9548_SEL_PLL       0x10  // Port 4
#define I2C_PS_9548_SEL_SC        0x20  // Port 5
#define I2C_PS_9548_SEL_FF        0x40  // Port 6
#define I2C_PS_9548_SEL_EXT       0x80  // Port 7


struct struct_i2c_ps_t
{
    u16     dev_id;       // device ID from xparameters.h
    u32     sclk_hz;      // I2C clock frequency in HZ
    XIicPs  inst;         // I2C instance
};
typedef struct struct_i2c_ps_t i2c_ps_t;


int i2c_ps_init(i2c_ps_t *i2c_ps);

int ic2_ps_9548_sel(i2c_ps_t *i2c_ps, u8 sel);

int i2c_ps_write_reg(i2c_ps_t *i2c_ps, u8 dev_addr, u8 reg, u8 data);
int i2c_ps_read_reg(i2c_ps_t *i2c_ps, u8 dev_addr, u8 reg, u8 *data);

int i2c_ps_write_buff(i2c_ps_t *i2c_ps, u8 dev_addr, u8 *buff, u32 len);




#endif /* _I2C_PS_FILE_ */
